jQuery(document).ready(function($) {

    var listParams = [];
    var urlNoParams = location.protocol + '//' + location.host + location.pathname; // URL without parameters
    var globalParams;

    dropdownIdeas();
    changePageRecipes();
    clearFilters();
    mobileDropdown();
    setVideoSize();
    setVideoSizeHorizontalMini();
    setVideoSizeHorizontal();

    // Page selection
    function changePageRecipes() {

        $(document).on('click','.navigation-pag > ul > li > a',function() {


        if( ! $(this).closest('li').hasClass('next-page') && ! $(this).closest('li').hasClass('prev-page') ) {

            $('.navigation-pag > ul > li').removeClass('active');
            $(this).closest('li').addClass('active');
            paged = $(this).html();

        } else {

            // ADDING OR REDUCING ONE PAGE
            $('.navigation-pag > ul > li').each(function() {
            if($(this).hasClass('active')) {
                currentPos = $(this).find('a').text();
            }
            });
            paged=currentPos;

            $('.navigation-pag > ul > li').removeClass('active');

            $('.navigation-pag > ul > li > a').each(function() {
            if( $(this).text() == currentPos ) {
                $(this).closest('li').addClass('active');
            }
            });
            paged=currentPos;

        }
        
        createUrlParams(paged);
        
        // Checking if we are in mobile version
        if( jQuery('.hf-terms-select').css('display') == 'none' ) {
            ajaxRecipes(paged);
        } else {
            ajaxRecipes(paged);
        }

        });

    }

    // Main behaviours to the filters
    function dropdownIdeas() {

        // Stopping default behaviour of the bootstrap dropdown, which closes after a click inside it
        jQuery(document).on('click', '.filter-wrapper .dropdown-menu', function (e) {
            e.stopPropagation();
        });

        jQuery(document).on('click', '.filter-wrapper .dropdown-menu li', function() {

            var checkB = jQuery(this).find('input');

            var typeF = jQuery(this).closest('.type-filter').data('filter');

            // Checking if the checkbox is checked
            if( checkB.is(':checked') ) { // If it's checked, we remove the tag
            
                jQuery(this).find('input').prop('checked', false);
                jQuery('.list-tags li').each(function() {
                    if( checkB.val() == jQuery(this).data('val') ) {
                        jQuery(this).remove();
                    }
                });

                // Filling both forms - Desktop and mobile
                if( typeF == 'mobile' ) {

                    jQuery('.filter-desktop .dropdown-check input').each(function() {

                        if( $(this).val() == checkB.val() ) { jQuery(this).prop('checked', false); }

                    });

                }

                if( typeF == 'desktop' ) {

                    jQuery('.filter-mobile .dropdown-check input').each(function() {

                        if( $(this).val() == checkB.val() ) { jQuery(this).prop('checked', false); }

                    });

                }

            } else { // If it isn't checked, we add the tag

                jQuery(this).find('input').prop('checked', true);
                var parent = jQuery(this).closest('.dropdown-ideas').data('id');
                var content = jQuery(this).find('.filter-name');
                jQuery('.list-tags').append('<li data-val="'+checkB.val()+'" data-drop="'+parent+'">'+content.html()+'<a class="tag-close">x</a></li>');

                // Filling both forms - Desktop and mobile
                if( typeF == 'mobile' ) {

                    jQuery('.filter-desktop .dropdown-check input').each(function() {

                        if( $(this).val() == checkB.val() ) { jQuery(this).prop('checked', true); }

                    });

                }

                if( typeF == 'desktop' ) {

                    jQuery('.filter-mobile .dropdown-check input').each(function() {

                        if( $(this).val() == checkB.val() ) { jQuery(this).prop('checked', true); }

                    });

                }
                
            }

            checkNoTags();
            createUrlParams();
            ajaxRecipes();

        });

        // Close tag by pressing X
        jQuery(document).on('click','.tag-close',function() {
            
            var cat = jQuery(this).closest('li').data('val');
            var dropdown = jQuery(this).closest('li').data('drop');

            jQuery(this).closest('li').remove();

            // Removing the checkbox of the dropdowns
            jQuery('.'+dropdown+'.dropdown-ideas').find('.dropdown-menu li').each(function() {

                if( jQuery(this).find('input').val() == cat ) {
                    jQuery(this).find('input').prop('checked', false);
                }

            });

            checkNoTags();
            createUrlParams();
            ajaxRecipes();

        });

    }

    // Concrete instructions for the mobile dropdown
    function mobileDropdown() {

        var openClose = false;

        jQuery('.dropdown-rec-mobile').on('click',function() {

            if( openClose == false ) {
                jQuery(this).css({'overflow':'visible'});
                openClose = true;
            }
            
        });

        jQuery(document).mouseup(function(e) {

            if( openClose == true ) {
                var container = $(".dropdown-rec-mobile");

                if (!container.is(e.target) // if the target of the click isn't the container...
                    && container.has(e.target).length === 0) // ... nor a descendant of the container
                {
                  jQuery('.dropdown-rec-mobile').css({'overflow':'hidden'});
                  openClose = false;
                }

            }

        });

    }

    // It creates an array with all the parameters
    function createArrParams() {

        var list = [];
        var i,j;
        var filters = document.querySelectorAll('ul.list-tags > li');

        // Putting in an array the selected filters
        for( i=0; i<filters.length; i++) {

            nameP = filters[i].getAttribute('data-drop');
            valP = filters[i].getAttribute('data-val');

            if( typeof list[ nameP ] == "undefined" ) {
                list[ nameP ] = [];
            }
            list[ nameP ].push( valP );
            
        };

        listParams = list;

    }

    // It clear all the filters
    function clearFilters() {

        jQuery('.filter-clear').on('click',function() {

            jQuery('.list-tags').empty();
            jQuery('.filter-wrapper .dropdown .dropdown-menu .dropdown-check input').prop('checked', false);
            createUrlParams();
            checkNoTags();
            ajaxRecipes();

        });

    }
    

    // It regenerates the parameters of the URL according to the current activated filters
    function createUrlParams(page = null) {

        var i,j,params='';

        createArrParams();

        // Creating the string of the params in the URL
        i = 0;
        for ( var l in listParams ) {

            if( i == 0 ) {
                params += "?r"+l+"=";
            } else {
                params += "&r"+l+"=";
            }

            for ( j=0; j<listParams[l].length; j++ ) {

                if( j == 0 ) {
                    params += listParams[l][j];
                } else {
                    params += ","+listParams[l][j];
                }
                
            }

            i++;

        }
        
        if( page != null ) {

            if( params != "" ) {
                spage = "&pag="+page;
            } else {
                spage = "?pag="+page;
            }
            
        } else {
            spage = "";
        }
        

        if( params ) {
            history.pushState(null, "", params+spage);
            params = params+spage;
        } else {
            history.pushState(null, "", urlNoParams+spage);
            params = spage;
        }

        globalParams = params;

    }

    // It generates a JSON string with the parameters
    function createJsonParams() {

        var i=0,j,json='[{';
        var lengthObject = Object.keys(listParams).length;http://test.aldi.es/recetas/carabineros-confitados/?pag=2

        // Creating the string of the JSON
        for ( var l in listParams ) {

            json += '"category":"'+l+'","values":"';

            for ( j=0; j<listParams[l].length; j++ ) {

                json += listParams[l][j];
                if( j != (listParams[l].length-1) ) {
                    json += ',';
                }
                
            }
            json += '"}';
            i++;
            if( i != (lengthObject) ) {
                json += ',{';
            }

        }

        json += ']';

        return json;

    }

    // It checks if there isn't selected tags, in order to hide the block
    function checkNoTags() {

        if( jQuery('ul.list-tags li').length > 0 ) {
            jQuery('.filter-tags').fadeIn();
            jQuery('.filter-clear').fadeIn();
        } else {
            jQuery('.filter-tags').fadeOut();
            jQuery('.filter-clear').fadeOut();
        }

    }

    // Ajax call
    function ajaxRecipes( paged = 1 ) {

        var listP = createJsonParams();

        var data = {
            action: 'loop_rec',
            security : S_Recipes.security,
            listParams: listP,
            paged: paged,
            paramsstring: globalParams
  		};

        jQuery.ajax({
            type: "POST",
            url: S_Recipes.ajaxurl,
            dataType: "html",
            data: data,
            beforeSend: function(){
                jQuery('.hf-loader').css({'display':'block'}).animate({'opacity':1});
            },
            success: function(msg) {

                $('.hf-results-row').fadeOut('slow', function() {
                    $('html,body').animate({
                    scrollTop: $(".up-pagination").offset().top-110},
                    'slow');
                    $('.hf-results-row').empty();
                    $('.hf-results-row').append(msg);
                    $('.hf-results-row').fadeIn("slow");
                });

            },
            error: function(jqXHR, exception) {

                console.log(jqXHR);

                $('.hf-results-row').fadeOut('slow', function() {
                    $('html,body').animate({
                    scrollTop: $(".up-pagination").offset().top-110},
                    'slow');
                    $('.hf-results-row').empty();
                    $('.hf-results-row').append("Lo sentimos, ha habido un error procesando su consulta. Por favor, inténtelo más tarde.");
                    $('.hf-results-row').fadeIn("slow");
                });

            },
            complete: function(){
                jQuery('.hf-loader').animate({'opacity':0}).delay("slow").css({'display':'none'});
            }
        });

    }

    function setVideoSize() {

        if( jQuery('#receta').length ) {
            
            if( jQuery('.rec-video-wrapper').length ) {
                
                widthVideo = jQuery('.rec-video-wrapper').outerWidth();
                heightVideo = ( widthVideo * 16 ) / 9;

                jQuery('.rec-video-wrapper').css({'height':heightVideo+'px'});


                jQuery(window).resize(function() {
                        
                    widthVideo = jQuery('.rec-video-wrapper').outerWidth();
                    heightVideo = ( widthVideo * 16 ) / 9;

                    jQuery('.rec-video-wrapper').css({'height':heightVideo+'px'});

                });
    
            }

        }

    }



	function setVideoSizeHorizontalMini() {
		if (jQuery('#receta').length) {
			if (jQuery('.rec-video-horizontal-mini').length) {
				widthVideo = jQuery('.rec-video-horizontal-mini').outerWidth();
				heightVideo = (widthVideo * 9) / 16;

				jQuery('.rec-video-horizontal-mini')
					.css({'height': heightVideo + 'px'});

				jQuery(window).resize(function() {
					widthVideo = jQuery('.rec-video-horizontal-mini').outerWidth();
					heightVideo = (widthVideo * 9) / 16;

					jQuery('.rec-video-horizontal-mini')
						.css({'height': heightVideo + 'px'});

					jQuery('.rec-video-horizontal-mini iframe')
						.css({'height': heightVideo + 'px'});
                });
			}
		}
	}



	function setVideoSizeHorizontal() {
		if (jQuery('#receta').length) {
			if (jQuery('.rec-video-horizontal').length) {
				widthVideo = jQuery('.rec-video-horizontal').outerWidth();
				heightVideo = (widthVideo * 9) / 16;

				jQuery('.rec-video-horizontal')
					.css({'height': heightVideo + 'px'});

				jQuery(window).resize(function() {
					widthVideo = jQuery('.rec-video-horizontal').outerWidth();
					heightVideo = (widthVideo * 9) / 16;

					jQuery('.rec-video-horizontal')
						.css({'height': heightVideo + 'px'});

					jQuery('.rec-video-horizontal iframe')
						.css({'height': heightVideo + 'px'});
                });
			}
		}
	}

});
