jQuery(document).ready(function($) {

  changePage();
  selectCat();

  // Page selection
  function changePage() {

    $(document).on('click','.navigation-pag > ul > li > a',function() {


      if( ! $(this).closest('li').hasClass('next-page') && ! $(this).closest('li').hasClass('prev-page') ) {

        $('.navigation-pag > ul > li').removeClass('active');
        $(this).closest('li').addClass('active');
        paged = $(this).html();

      } else {

        // ADDING OR REDUCING ONE PAGE
        $('.navigation-pag > ul > li').each(function() {
          if($(this).hasClass('active')) {
            currentPos = $(this).find('a').text();
          }
        });
        paged=currentPos;

        $('.navigation-pag > ul > li').removeClass('active');

        $('.navigation-pag > ul > li > a').each(function() {
          if( $(this).text() == currentPos ) {
            $(this).closest('li').addClass('active');
          }
        });
        paged=currentPos;

      }

      // Adding page to the URL
      var urlParams = window.location.href;
      if( urlParams.indexOf("pag") != -1 ) { // Checking if there's a page set previosly

        var urlNoPage = urlParams.substring(0,urlParams.indexOf("pag")-1);

      } else {

        var urlNoPage = urlParams;

      }
      
      if( urlParams.indexOf("?categ") != -1 ) {
        history.pushState(null, "", urlNoPage+"&pag="+paged);
      } else {
        history.pushState(null, "", urlNoPage+"?pag="+paged);
      }

      // Checking if we are in mobile version
      if( jQuery('.hf-terms-select').css('display') == 'none' ) {
        loadFilter(getCode(),getCurrentCat(),paged);
      } else {
        loadFilter(getCodeSelect(),getCurrentCat(),paged);
      }

    });

  }

  function getCurrentCat() {

    var code = jQuery('.hf-terms-list').data('tipo');
    return code;

  }

  function getCode() {

    empty = true;

    jQuery('.hf-terms-list a.active').each(function() {
      empty=false;
      code=$(this).data('cat');
    });

    if(empty==true) {
      return "";
    } else {
      return code;
    }

  }

  function getCodeSelect() {

    empty = true;

    jQuery('.hf-terms-select input').each(function() {
      empty=false;
      code=$(this).val();
    });

    if(empty==true) {
      return "";
    } else {
      return code;
    }

  }

  function selectCat() {

    jQuery('.hf-terms-list a').on('click',function() {

      var urlParams = window.location.href;
      var urlNoParams = location.protocol + '//' + location.host + location.pathname;

      var cVal = $(this).data('cat');
      var cName = $(this).html();

      if( cVal != null ) {
        history.pushState(null, "", "?categ="+cVal);
      } else {
        history.pushState(null, "", urlNoParams);
      }

      jQuery('.hf-terms-list a').removeClass('active');
      $(this).addClass('active');

      jQuery('.hf-terms-select .dropdown-toggle .dropdown-title').html(cName);
      jQuery('.hf-terms-select .dropdown-ideas li').removeClass('checked');

      // Changing the selected option in desktop, just in case the user goes back to it
      jQuery('.hf-terms-select .dropdown-ideas li').each(function() {

        if( cVal == jQuery(this).data('val') ) {
          jQuery(this).addClass('checked');
        }

      });

      // Changing the page to the first
      $('.navigation-pag > ul > li').removeClass('active');
      $('.navigation-pag > ul > li:first-child').addClass('active');

      loadFilter($(this).data('cat'),getCurrentCat(),1);

    });

    jQuery('.hf-terms-select .dropdown-ideas li').on('click',function() {

      var urlParams = window.location.href;
      var urlNoParams = location.protocol + '//' + location.host + location.pathname;

      var cVal = $(this).data('val');
      var cName = $(this).html();

      // Putting the selected option on top
      jQuery('.hf-terms-select .dropdown-toggle .dropdown-title').html(cName);

      // Coloring the selected option
      jQuery('.hf-terms-select .dropdown-ideas li').removeClass('checked');
      jQuery(this).addClass('checked');

      if( cVal != null ) {
        history.pushState(null, "", "?categ="+cVal);
      } else {
        history.pushState(null, "", urlNoParams);
      }
      
      // Changing the selected option in desktop, just in case the user goes back to it
      jQuery('.hf-terms-list a').each(function() {

        if( cVal == jQuery(this).data('cat') ) {
          jQuery('.hf-terms-list a').removeClass('active');
          $(this).addClass('active');
        }

      });

      $('.navigation-pag > ul > li').removeClass('active');
      $('.navigation-pag > ul > li:first-child').addClass('active');

      loadFilter(cVal,getCurrentCat(),1);

    });
    
  }

  // It loads the results depending on the button the user clicks
  function loadFilter(categ,tax,paged) {

    if(categ!='') {
      var term_code = categ;
    } else {
      var term_code = "";
    }

    if(tax!='') {
      var term_cat = tax;
    } else {
      var term_cat = "";
    }

    var data = {
    	action: 'show_filter',
    	security : S_Filter.security,
      term_code: term_code,
      term_cat: term_cat,
      paged: paged
  		};

      jQuery.ajax({
          type: "POST",
          url: S_Filter.ajaxurl,
          dataType: "html",
          data: data,
          beforeSend: function(){
              jQuery('.hf-loader').css({'display':'block'}).animate({'opacity':1});
          },
          success: function(msg) {

            // No results
            if(msg=="no") {

              $('.hf-results-row').fadeOut('slow', function() {
                $('html,body').animate({
                  scrollTop: $(".up-pagination").offset().top-110},
                'slow');
                $('.hf-results-row').empty();
                $('.hf-results-row').append("No hay resultados");
                $('.hf-results-row').fadeIn("slow");
              });

            } else { // There are results

              $('.hf-results-row').fadeOut('slow', function() {
                $('html,body').animate({
                  scrollTop: $(".up-pagination").offset().top-110},
                'slow');
                $('.hf-results-row').empty();
                $('.hf-results-row').append(msg);
                $('.hf-results-row').fadeIn("slow");
              });

            }


          },
          error: function(msg) {
            console.log(msg);
          },
          complete: function(){
              jQuery('.hf-loader').animate({'opacity':0}).delay("slow").css({'display':'none'});
          }
      });

  }

});
