<?php

class recetas extends ideasAldi {

    private $urlParams = array();
    private $post_t = 'receta';
    private $paramsString;
    private $cpage;

    public function __construct() {

        // Retrieving data from the URL
        $this->fill_filter_data();
        $this->params_string();

        // STYLES
        add_action( 'wp_enqueue_scripts', array($this,'stylesScriptsRecetas' ));

        // Creating post type
        add_action( 'init', array( $this, 'create_recetas' ) );

        // Creating categories
        add_action( 'init', array( $this, 'create_recetas_cats' ) );

        // Creating shortcode
        add_shortcode( 'recipes', array( $this, 'print_rec' ) );

        // AJAX Handlers
		add_action( 'wp_ajax_loop_rec', array( $this, 'loop_rec' ));
		add_action( 'wp_ajax_nopriv_loop_rec', array( $this, 'loop_rec' ));

    }

    public function stylesScriptsRecetas() {

        // SCRIPTS
        wp_register_script( 'recipes', plugin_dir_url( __FILE__ ) . 'js/recetas.js', array('jquery'), '', true );

        wp_localize_script( 'recipes', 'S_Recipes', array(
            // URL to wp-admin/admin-ajax.php to process the request

            'ajaxurl' => admin_url( 'admin-ajax.php' ),

            // generate a nonce with a unique ID "myajax-post-comment-nonce"
            // so that you can check it later when an AJAX request is sent
            'security' => wp_create_nonce( 'recipes-ajax' ),

        ));

    }

    // It puts the parameters of the URL into private variables
    public function fill_filter_data() {

        $i=0;

        // Getting filters from the URL
        $queryURL = parse_url( html_entity_decode( esc_url( add_query_arg( $arr_params ) ) ) );
        parse_str( $queryURL['query'], $getVar );
        
        if( $getVar['rplato']!='' ) {
            $this->urlParams[$i]['category'] = 'plato';
            $this->urlParams[$i]['values'] = $getVar['rplato'];
            $i++;
        }
        if( $getVar['rdificultad']!='' ) {
            $this->urlParams[$i]['category'] = 'dificultad';
            $this->urlParams[$i]['values'] = $getVar['rdificultad'];
            $i++;
        }
        if( $getVar['rraciones']!='' ) {
            $this->urlParams[$i]['category'] = 'raciones';
            $this->urlParams[$i]['values'] = $getVar['rraciones'];
            $i++;
        }
        if( $getVar['rtiempo']!='' ) {
            $this->urlParams[$i]['category'] = 'tiempo';
            $this->urlParams[$i]['values'] = $getVar['rtiempo'];
            $i++;
        }
        if( $getVar['respeciales']!='' ) {
            $this->urlParams[$i]['category'] = 'especiales';
            $this->urlParams[$i]['values'] = $getVar['respeciales'];
            $i++;
        }
        if( $getVar['rprecio']!='' ) {
            $this->urlParams[$i]['category'] = 'precio';
            $this->urlParams[$i]['values'] = $getVar['rprecio'];
            $i++;
        }
        if( $getVar['pag']!='' ) {
            $this->cpage = $getVar['pag'];
        } else {
            $this->cpage = 1;
        }

    }

    // It creates the string for keeping the filter in the URL
    public function params_string() {

        if( $_SERVER['QUERY_STRING'] ) {
            $this->paramsString = "?".$_SERVER['QUERY_STRING'];
        }

    }

    // Shortcode function
    public function print_rec() {

        wp_enqueue_script( 'recipes' );

        $this->print_rec_filter();
        echo '<div class="hf-results"><div class="container"><div class="row hf-results-row">';
        $this->print_rec_archive($this->urlParams, $this->cpage);
        echo "</div></div></div>";

    }

    // Printing the filters above the results
    public function print_rec_filter() {

        echo '<div class="container">';
		echo '<div class="filter-header-wrapper">';
		echo '	<h2>'.get_field('rec_main_tit','option').'</h2>';
		echo '	<div class="main-text">'.get_field('rec_main_txt','option').'</div>';
		echo '	<div class="filter-text">'.get_field('rec_filter','option').'</div>';
		echo '	<div class="filter-clear" style="'.(( count($this->urlParams) == 0 ) ? 'display:none;' : '' ).'">'.__("Eliminar filtros","ideas").'</div>';
		echo '</div>';
        echo '</div>';

        // Filters
        echo "<div class='up-pagination'></div>";

        echo '<div class="filter-wrapper">';

        // Desktop
        echo '<div class="container filter-desktop type-filter" data-filter="desktop">';

        echo $this->get_selects('plato');
        echo $this->get_selects('dificultad','term_id');
        echo $this->get_selects('tiempo');
        echo $this->get_selects('especiales');
        echo $this->get_selects('precio');

        echo '</div>';

        // Mobile
        echo '<div class="container filter-mobile type-filter" data-filter="mobile">';

        $this->mobileSelect();

        echo '</div>';

        echo '</div>';

        // Tags
        echo '<div class="filter-tags" style="'.(( count($this->urlParams) == 0 ) ? 'display:none;' : '' ).'">';
        echo '<div class="container">';

        echo '<ul class="list-tags">';

        $this->current_filters();
        
        echo '</ul>';

        echo '</div>';
        echo '</div>';

    }

    // It prints the current selected filters through the URL
    public function current_filters() {

        foreach ( $this->urlParams as $key => $params ) {

            $p = explode(",",$params['values']);

            foreach ( $p as $item ) {
                $name = get_term_by( 'id', $item, $params['category'] );
                echo '<li data-val="'.$item.'" data-drop="'.$params['category'].'">'.$name->name.'<a class="tag-close">x</a></li>';
            }

        }

    }

    // It return the select of the given taxonomy.
    // It gets the parameters from the URL.
    public function get_selects( $tax, $order = 'name' ) {

        // Getting all the terms
        $terms = get_terms( array(
            'taxonomy' => $tax,
            'hide_empty' => true,
            'orderby' => $order
        ) );

        $sel = '';

        $sel .= '<div class="dropdown dropdown-ideas '.$tax.'" data-id="'.$tax.'">';
        $sel .= '<button class="btn btn-default dropdown-toggle" type="button" id="dropdownMenu'.$tax.'" data-toggle="dropdown" aria-haspopup="true" aria-expanded="true">';
        $sel .= '<span class="dropdown-title">'.$tax.'</span>';
        $sel .= '    <span class="caret"></span>';
        $sel .= '</button>';
        $sel .= '<ul class="dropdown-menu" aria-labelledby="dropdownMenu'.$tax.'">';

        // Printing the terms
        foreach ( $terms as $term ) {
            $checked = ( $this->is_cat_active($term->term_id) ) ? 'checked' : '' ;
            $sel .= '<li><div class="filter-name">'.$term->name.'</div><div class="dropdown-check"><input type="checkbox" value="'.$term->term_id.'" id="'.$tax.$term->term_id.'" '.$checked.'><label for="'.$tax.$term->term_id.'"></label></div></li>';
        }
        
        $sel .= '</ul>';
        $sel .= '</div>';

        return $sel;

    }

    // It prints special select for mobile
    public function mobileSelect() {
    ?>
        <div class="dropdown-rec-mobile">

            <div class="dropdown-rec-mobile-wrapper">

                <?php
                echo $this->get_selects('plato');
                echo $this->get_selects('dificultad','term_id');
                echo $this->get_selects('tiempo');
                echo $this->get_selects('especiales');
                echo $this->get_selects('precio');
                ?>

            </div>

        </div>
    <?php
    }

    // No results found
    public function noResults() {

        echo "<span class='ideas-rec-no-results'>";
        echo "<div class='ideas-rec-no-results-img'><img src='".plugin_dir_url( __FILE__ )."imgs/no-results-recipes.png'></div>";
        echo "<div class='text'>".get_field('rec_norec','option')."</div>";
        echo "</span>";

        $args = array (
            'showposts' => 4,
            'post_status' => 'publish',
            'post_type' => $this->post_t,
            'order' => 'DESC'
        );

        $query = new WP_Query( $args );

        if( $query->have_posts() ) :
        
            $i=1;
            
            // Printing the posts
            while( $query->have_posts()) {
                $query->the_post();

                /************** 2 COLUMNS *****************/
                echo '<div class="col-xs-12 col-sm-12 col-md-6 hf-post">';
                include('template-article-archive.php');
                echo '</div>';

                if($i%2==0) {
                echo "<span class='clearfix'></span>";
                }
                echo "<span class='clearfix visible-sm'></span>";

                $i++;

            }

            echo "<span class='clearfix'></span>";

            //numeric_pagination($query,$paged,true,0);
            wp_reset_postdata();
        
        else:

            echo __('¡Oh! No hay ninguna receta disponible en este momento.');

        endif;

    }

    // It returns true if the category is in the URL parameters
    // @ cid - the id of the category
    public function is_cat_active( $cid ) {

        $found = false;

        foreach ( $this->urlParams as $key => $params ) {

            $p = explode(",",$params['values']);

            foreach ( $p as $item ) {
                
                if( $item == $cid ) {
                    $found = true;
                    break;
                }

            }

        }

        return $found;

    }

    // It gets the ajax call and show the results
    public function loop_rec() {

        check_ajax_referer( 'recipes-ajax', 'security' );
        
        $this->paramsString = $_POST['paramsstring'];
        if( $_POST['paged'] ) {
            $paged = $_POST['paged'];
        } else {
            $paged = 1;
        }
        $listP = (array) json_decode(stripslashes($_POST['listParams']), true);
        $this->print_rec_archive($listP,$paged);

        die();

    }

    // It returns all the results of the required recipes
    public function print_rec_archive( $filters=null, $paged = 1) {

        $postspp = get_option( 'posts_per_page' );

        if( $filters ) {

            $args = array (
                'showposts' => $postspp,
                'paged' => $paged,
                'tax_query' => array(
                    'relation' => 'AND'
                ),
                'post_status' => 'publish',
                'post_type' => $this->post_t
            );

            foreach ( $filters as $f ) {

                $values = explode( ",", $f['values'] );

                $args['tax_query'][] = array(
                    'taxonomy' => $f['category'],
                    'field' => 'term_id',
                    'terms' => $values
                );

            }

        } else {

            $args = array (
                'showposts' => $postspp,
                'paged' => $paged,
                'post_status' => 'publish',
                'post_type' => $this->post_t
            );

        }

        $query = new WP_Query( $args );

        if( !empty($this->paramsString) ) {

            $params = $this->paramsString;
            
        } else {

            $params = "";

        }
        

        if( $query->have_posts() ) :
        
            $i=1;
            
            // Printing the posts
            while( $query->have_posts()) {
                $query->the_post();

                /************** 2 COLUMNS *****************/
                echo '<div class="col-xs-12 col-sm-12 col-md-6 hf-post">';
                include('template-article-archive.php');
                echo '</div>';

                if($i%2==0) {
                echo "<span class='clearfix'></span>";
                }
                echo "<span class='clearfix visible-sm'></span>";

                $i++;

            }

            echo "<span class='clearfix'></span>";

            numeric_pagination($query,$paged,true,0);
            wp_reset_postdata();

        else :
    
            $this->noResults();

        endif;

    }

    // It creates the custom type "Recetas"
    public function create_recetas () {

        register_post_type( 'receta',
            array(
            'labels' => array(
                'name' => __( 'Recetas' ),
                'singular_name' => __( 'Receta' )
            ),
            'public' => true,
            'has_archive' => true,
            'supports' => array( 'title','thumbnail','excerpt','editor' ),
            'menu_icon'   => 'dashicons-carrot',
            'rewrite' => array( 'slug' => 'recetas' ),
            )
        );

    }

    // CREATING NEW CATEGORIES FOR "RECETAS"
    function create_recetas_cats() {

        register_taxonomy(
            'plato',
            'receta',
            array(
                'label' => __( 'Plato' ),
                'rewrite' => array( 'slug' => 'plato' ),
                'hierarchical' => true
            )
        );

        register_taxonomy(
            'dificultad',
            'receta',
            array(
                'label' => __( 'Dificultad' ),
                'rewrite' => array( 'slug' => 'dificultad' ),
                'hierarchical' => true
            )
        );

        register_taxonomy(
            'raciones',
            'receta',
            array(
                'label' => __( 'Raciones' ),
                'rewrite' => array( 'slug' => 'comensales' ),
                'hierarchical' => true
            )
        );

        register_taxonomy(
            'tiempo',
            'receta',
            array(
                'label' => __( 'Tiempo' ),
                'rewrite' => array( 'slug' => 'tiempo' ),
                'hierarchical' => true
            )
        );

        register_taxonomy(
            'especiales',
            'receta',
            array(
                'label' => __( 'Especiales' ),
                'rewrite' => array( 'slug' => 'especial' ),
                'hierarchical' => true
            )
        );

        register_taxonomy(
            'precio',
            'receta',
            array(
                'label' => __( 'Precio' ),
                'rewrite' => array( 'slug' => 'especial' ),
                'hierarchical' => true
            )
        );

    }

}

// Llamada a recetas
$recetas = new recetas();

?>