<?php get_header(); ?>

<div class="push-cab"></div>
<div class="banner-archive">
	<img class="banner-archive-img" src="<?php echo get_field('diy_banner','option')['url']; ?>" alt="<?php echo get_field('diy_banner','option')['alt']; ?>">
	<div class="container">
		<h1 class="banner-title">
			<?php echo get_field('diy_banner_txt','option'); ?>
		</h1>
	</div>
</div>


<article id="post-<?php the_ID(); ?>" class="container" role="article" itemscope itemtype="<?php if($receta) { echo "http://schema.org/Recipe"; } else { echo "http://schema.org/BlogPosting"; } ?>">

  <div class="article-wrapper">
  <?php while ( have_posts() ) : the_post(); ?>

      <h1 <?php if(!$receta) { echo "itemprop='name'"; } ?>><?php echo get_the_title(); ?></h1>
      <meta itemprop="datePublished" content="<?php echo get_the_date("Y-m-d"); ?>">
      <?php the_content(); ?>

      <!-- RECETA FIELDS -->
      <?php if(have_rows('rec_rep')) { ?>
        <?php while(have_rows('rec_rep')) { the_row(); ?>
          <div id="receta">

            <?php
            // Showing only if the user introduced a text for the field
            if(get_sub_field('rec_tit')) {
            ?>
            <div class="tit-receta">
              <h2 class="receta-h4"><?php echo get_sub_field('rec_tit'); ?></h2>
            </div>
            <?php } else { ?>
              <meta itemprop="name" content="<?php echo get_the_title(); ?>">
            <?php
            }
            ?>

            <?php if(get_sub_field('rec_img')) { ?>
            <?php foreach(get_sub_field('rec_img') as $img) : ?>
            <img src="<?php echo $img['url']; ?>" alt="<?php echo $img['alt']; ?>" class="featured-receta" itemprop="image">
            <?php endforeach; ?>
            <?php } ?>

            <?php
            // Extra information: dish, quantity, difficulty and time
            if(get_sub_field('rec_tcr')) { // Checking if all the data are active or not
            ?>
            <div class="rec-extra">

              <!-- Tipo de plato -->
              <div class="rec-extra-col">
                <span class="rec-extra-left">
                  <?php
                  echo "<img src='".get_template_directory_uri()."/assets/imgs/recetas/cuberteria.png' alt='Cubertería'>";
                  ?>
                </span>
                <span class="rec-extra-right"><h4><?php _e('Plato'); ?></h4>
                  <?php
                  switch( get_sub_field('rec_tipoplato') ) {

                    case "entrante" : echo "Entrante";
                      break;
                    case "primero" : echo "Primero";
                      break;
                    case "segundo" : echo "Segundo";
                      break;
                    case "postre" : echo "Postre";
                      break;

                  }
                  ?>
                </span>
              </div>

              <!-- Comensales -->
              <div class="rec-extra-col">
                <span class="rec-extra-left"><img src="<?php echo get_template_directory_uri(); ?>/assets/imgs/recetas/comensal.png" alt="Icono de una persona"></span>
                <span class="rec-extra-right"><h4><?php _e('Raciones'); ?></h4><?php echo get_sub_field('rec_raciones'); ?></span>
              </div>

              <!-- Dificultad -->
              <div class="rec-extra-col">
                <span class="rec-extra-left">
                  <?php
                  echo "<img src='".get_template_directory_uri()."/assets/imgs/recetas/estrella.png'>";
                  ?>
                </span>
                <span class="rec-extra-right"><h4><?php _e('Dificultad'); ?></h4>
                  <?php
                  switch( get_sub_field('rec_dif') ) {

                    case "superchef" : echo "Hoy me siento superchef";
                      break;
                    case "intentarlo" : echo "Venga, ¡voy a intentarlo!";
                      break;
                    case "cocina-no" : echo "La cocina no es lo mío";
                      break;

                  }
                  ?>
                </span>
              </div>

              <!-- Tiempo de preparación -->
              <div class="rec-extra-col">
                <span class="rec-extra-left">
                  <img src="<?php echo get_template_directory_uri(); ?>/assets/imgs/recetas/reloj.png" alt="Icono de un reloj">
                </span>
                <span class="rec-extra-right"><h4><?php _e('Tiempo'); ?></h4><?php echo get_sub_field('rec_tiem'); ?></span>
              </div>

            </div>
            <?php
            }
            ?>

            <div class="row row-recetas">
              <?php
              if(get_sub_field('rec_ing')) {
              ?>
                <div class="col-xs-12 col-md-4">

                  <!-- Ingredientes -->
                  <div class="rec-ingredientes">
                    <div class="rec-ingredientes-header">
                      <h3><?php echo get_sub_field('rec_tit_ing'); ?></h3>
                      <img class="rec-ingredientes-icono" src="<?php echo plugin_dir_url( __FILE__ ); ?>imgs/lista-icono.png" alt="Icono de listado">
                    </div>
                    <div class="rec-ingredientes-wrapper">
                      <?php echo get_sub_field('rec_ing'); ?>
                    </div>
                  </div>

                  <!-- Featured product -->
                  <?php
                  if( get_sub_field('rec_pd') ) :
                  ?>
                  <div class="rec-featured-product">

                    <div class="rec-featured-product-header">
                      <h3><?php echo get_sub_field('rec_pd_tit'); ?></h3>
                      <img class="rec-featured-product-icon" src="<?php echo get_template_directory_uri(); ?>/assets/imgs/recetas/lista-icono.png" alt="Icono de listado">
                    </div>
                    <div class="rec-featured-product-wrapper">
                      <?php
                      if( get_sub_field('rec_pd_img') ) {
                        echo "<img src='".get_sub_field('rec_pd_img')['url']."' alt='".get_sub_field('rec_pd_img')['alt']."'>";
                      }
                      ?>
                      <div class="rec-featured-product-wrapper-text">
                        <h4><?php echo get_sub_field('rec_pd_prod'); ?></h4>
                        <?php
                        if( get_sub_field('rec_pd_link') ) {
                          ?>
                          <a href="<?php echo get_sub_field('rec_pd_link'); ?>" target="_blank"><?php _e('Ver producto','ideas'); ?></a>
                          <?php
                        }
                        ?>
                      </div>
                    </div>

                  </div>
                  <?php
                  endif;
                  ?>

                </div>
                <div class="col-xs-12 col-md-8">
                  <div class="rec-contenido">
                    <h3><?php echo get_sub_field('rec_tit_txt'); ?></h3>
                    <div itemprop="recipeInstructions"><?php echo get_sub_field('rec_txt'); ?></div>
                  </div>
                </div>
              <?php
              } else {
              ?>
                <div class="col-xs-12">
                  <div class="rec-contenido">
                    <h3><?php echo get_sub_field('rec_tit_txt'); ?></h3>
                    <div itemprop="recipeInstructions"><?php echo get_sub_field('rec_txt'); ?></div>
                  </div>
                </div>
              <?php
              }
              ?>
            </div>

          </div>
        <?php } ?>
      <?php } ?>


      <!-- Productos relacionados -->
      <?php if(get_field('prr_act')) { ?>

      <?php
      echo "<div class='related-products'>";
      echo "<h3 class='related-products-h3'>".get_field('prr_txt')."</h3>";

      $btntxt = get_field('prr_btn');

      if(have_rows('prr_rep')) :

        $trows=0;
        while(have_rows('prr_rep')) { the_row();
          $trows++;
        }

        $wpr = 100/$trows;

        while(have_rows('prr_rep')) : the_row();


          echo "<div class='item' style='width:".$wpr."%'>";
          echo "<div class='item-wrapper'>";
          echo "<img src='".get_sub_field('prr_img')['url']."' alt='".get_sub_field('prr_img')['alt']."'>";
          echo "<div class='item-subitems'>";
          echo "<h4>".get_sub_field('prr_tit')."</h4>";
          echo "<div>".get_sub_field('prr_desc')."</div>";
          if(get_sub_field('prr_link')) {
            echo "<a href='".get_sub_field('prr_link')."' target='_blank'>".$btntxt."</a>";
          }
          if(get_sub_field('prr_precio')) {
            echo "<div class='precio'>".get_sub_field('prr_precio')."€</div>";
          }
          echo "</div>";
          echo "</div>";
          echo "</div>";

        endwhile;

      endif;

      ?>

      <?php
      echo "</div>";
      ?>
      <?php } ?>

  <?php endwhile; // end of the loop. ?>
  </div>

  <!-- RECIPE TAGS -->
  <?php include( plugin_dir_path( __FILE__ ).'template-tags.php' ); ?>
  

  <!-- ARROWS -->
  <?php echo do_shortcode('[prev-next-arrows]'); ?>

  <?php
  // Getting current URL to share it
  global $wp;
  $current_url = add_query_arg( $wp->query_string, '', home_url( $wp->request ) );
  ?>
  <div class="share-portfolio">
    <span class="share-portfolio-text"><?php _e('Compartir en'); ?></span>
    <a href="https://www.facebook.com/sharer/sharer.php?u=<?php echo $current_url; ?>" onclick="window.open(this.href, 'mywin','left=20,top=20,width=500,height=500,toolbar=1,resizable=0'); return false;"><i class="fa fa-facebook"></i></a>
    <a href="https://twitter.com/intent/tweet?text=<?php echo $current_url; ?>" onclick="window.open(this.href, 'mywin','left=20,top=20,width=500,height=500,toolbar=1,resizable=0'); return false;"><i class="fa fa-twitter"></i></a>
    <a href="mailto:?subject=[ALDI] <?php echo get_the_title(); ?>&body=<?php echo $current_url; ?>"><i class="fa fa-envelope"></i></a>
  </div>

  <!-- NEWSLETTER SUBSCRIPTION -->
  <?php echo do_shortcode('[suscribir-newsletter-posts]'); ?>

</article><!-- #main -->

<!-- RELATED POSTS -->
<?php echo do_shortcode('[related-portfolios]'); ?>

<?php get_footer(); ?>
