<?php
get_header();
wp_enqueue_script( 'recipes' );
?>

<div class="push-cab"></div>
<div class="banner-archive">
	<img class="banner-archive-img" src="<?php echo get_field('rec_banner','option')['url']; ?>" alt="<?php echo get_field('rec_banner','option')['alt']; ?>">
	<div class="container">
		<h1 class="banner-title">
			<?php echo get_field('rec_banner_txt','option'); ?>
		</h1>
	</div>
</div>


<article id="post-<?php the_ID(); ?>" class="container" role="article" itemscope itemtype="<?php if($receta) { echo "http://schema.org/Recipe"; } else { echo "http://schema.org/BlogPosting"; } ?>">

  <div class="article-wrapper">
  <?php while ( have_posts() ) : the_post(); ?>

      <h1 <?php if(!$receta) { echo "itemprop='name'"; } ?>><?php echo get_the_title(); ?></h1>
      <meta itemprop="datePublished" content="<?php echo get_the_date("Y-m-d"); ?>">
      <?php the_content(); ?>

      <!-- RECETA FIELDS -->
      <?php if(have_rows('rec_rep')) { ?>
        <?php while(have_rows('rec_rep')) { the_row(); ?>

          <?php
          $hasVideo = false;
          if( get_sub_field('rec_video') && get_sub_field('rec_youtube') ) {
            $hasVideo = true;
          }
          $verticalVideo = false;
          if( get_sub_field('rec_video') && get_sub_field('rec_video_vertical') ) {
            $verticalVideo = true;
          }

          $hasPrice = false;
          $price = wp_get_post_terms( $post->ID, 'precio' );
          if( !empty($price) ) {
            $hasPrice = true;
          }
          ?>
          <div id="receta">

            <?php
            // Showing only if the user introduced a text for the field
            if(get_sub_field('rec_tit')) {
            ?>
            <div class="tit-receta">
              <h2 class="receta-h4"><?php echo get_sub_field('rec_tit'); ?></h2>
            </div>
            <?php } else { ?>
              <meta itemprop="name" content="<?php echo get_the_title(); ?>">
            <?php
            }
            ?>

            <!-- ********** Extra information: dish, quantity, difficulty and time ************ -->

            <?php $post_type = get_post_type( $post->ID ); ?>
            <div class="rec-extra">

              <!-- Tipo de plato -->
              <div class="rec-extra-col <?php echo $hasPrice ? : 'no-price'; ?>">
                <span class="rec-extra-left">
                  <?php
                  echo "<img src='".plugin_dir_url( __FILE__ )."imgs/cuberteria.png' alt='Cubertería'>";
                  ?>
                </span>
                <span class="rec-extra-right"><h4><?php _e('Plato'); ?></h4>
                  <?php
                  $value = wp_get_post_terms( $post->ID, 'plato' );
                  echo '<a href="'.get_post_type_archive_link( $post_type ).'?rplato='.$value[0]->term_id.'">'.$value[0]->name.'</a>';
                  ?>
                </span>
              </div>

              <!-- Comensales -->
              <div class="rec-extra-col <?php echo $hasPrice ? : 'no-price'; ?>">
                <span class="rec-extra-left"><img src="<?php echo plugin_dir_url( __FILE__ ); ?>imgs/comensal.png" alt="Icono de una persona"></span>
                <span class="rec-extra-right"><h4><?php _e('Raciones'); ?></h4>
                  <?php
                  $value = wp_get_post_terms( $post->ID, 'raciones' );
                  echo $value[0]->name;
                  ?>
                </span>
              </div>

              <!-- Dificultad -->
              <div class="rec-extra-col <?php echo $hasPrice ? : 'no-price'; ?>">
                <span class="rec-extra-left">
                  <?php
                  echo "<img src='".plugin_dir_url( __FILE__ )."imgs/estrella.png'>";
                  ?>
                </span>
                <span class="rec-extra-right"><h4><?php _e('Dificultad'); ?></h4>
                  <?php
                  $value = wp_get_post_terms( $post->ID, 'dificultad' );
                  echo '<a href="'.get_post_type_archive_link( $post_type ).'?rdificultad='.$value[0]->term_id.'">'.$value[0]->name.'</a>';
                  ?>
                </span>
              </div>

              <!-- Tiempo de preparación -->
              <div class="rec-extra-col <?php echo $hasPrice ? : 'no-price'; ?>">
                <span class="rec-extra-left">
                  <img src="<?php echo plugin_dir_url( __FILE__ ); ?>imgs/reloj.png" alt="Icono de un reloj">
                </span>
                <span class="rec-extra-right"><h4><?php _e('Tiempo'); ?></h4>
                  <?php
                  $value = wp_get_post_terms( $post->ID, 'tiempo' );
                  echo '<a href="'.get_post_type_archive_link( $post_type ).'?rtiempo='.$value[0]->term_id.'">'.$value[0]->name.'</a>';
                  ?>
                </span>
              </div>

              <!-- Precio -->
              <?php if( $hasPrice ) { ?>
              <div class="rec-extra-col <?php echo $hasPrice ? : 'no-price'; ?>">
                <span class="rec-extra-left">
                  <img src="<?php echo plugin_dir_url( __FILE__ ); ?>imgs/precio.png" alt="Icono de un euro">
                </span>
                <span class="rec-extra-right"><h4><?php _e('Precio'); ?></h4>
                  <?php
                  $value = wp_get_post_terms( $post->ID, 'precio' );
                  echo '<a href="'.get_post_type_archive_link( $post_type ).'?rprecio='.$value[0]->term_id.'">'.$value[0]->name.'</a>';
                  ?>
                </span>
              </div>
              <?php } ?>

            </div>

            <!-- ****************** END EXTRA INFORMATION ******************* -->

            <div class="row row-recetas">
              <?php if (get_sub_field('rec_ing')): ?>
                <div class="<?php echo ( $hasVideo && $verticalVideo ) ? 'col-md-5' : 'col-md-4' ; ?> col-xs-12">
					<?php if (!$hasVideo): ?>
						<?php foreach(get_sub_field('rec_img') as $img) : ?>
							<img
								src="<?php echo $img['url']; ?>"
								alt="<?php echo $img['alt']; ?>"
								class="featured-receta hidden-md hidden-lg"
								itemprop="image"
							>
						<?php endforeach; ?>
					<?php elseif (!$verticalVideo): ?>
						<?php $videoUrl =
							'//www.youtube.com/embed/' .
							convertYoutube(get_sub_field('rec_youtube')) .
							'?rel=0&amp;controls=0&amp;showinfo=0';
						?>

						<div class="rec-video-horizontal-mini hidden-md hidden-lg">
							<iframe
								src="<?= $videoUrl ?>"
								width="100%"
								height="100%"
								frameborder="0"
								allowfullscreen="allowfullscreen"
								gesture="media"
								allow="encrypted-media"
							></iframe>
						</div>
					<?php endif; ?>

                  <?php if( !$hasVideo || !$verticalVideo  ) { ?>
                  <!-- Ingredientes -->
                  <div class="rec-ingredientes">
                    <div class="rec-ingredientes-header">
                      <h3><?php echo get_sub_field('rec_tit_ing'); ?></h3>
                      <img class="rec-ingredientes-icono" src="<?php echo plugin_dir_url( __FILE__ ); ?>imgs/lista-icono.png" alt="Icono de listado">
                    </div>
                    <div class="rec-ingredientes-wrapper">
                      <?php echo get_sub_field('rec_ing'); ?>
                    </div>
                  </div>
                  <?php } else { ?>

                    <div class="rec-video-wrapper">
                      <iframe src="//www.youtube.com/embed/<?php echo convertYoutube( get_sub_field('rec_youtube') ); ?>?rel=0&amp;controls=0&amp;showinfo=0" width="100%" height="100%" frameborder="0" allowfullscreen="allowfullscreen" gesture="media" allow="encrypted-media"></iframe>
                    </div>

                  <?php } ?>

                  <!-- Featured product -->
                  <?php
                  if( get_sub_field('rec_pd') ) :
                    $product = get_sub_field('rec_pd_link');
                    if( get_post_status( $product->ID ) == 'publish' ) {
                    ?>
                      <div class="rec-featured-product">

                        <div class="rec-featured-product-header">
                          <h3><?php echo get_sub_field('rec_pd_tit'); ?></h3>
                          <img class="rec-featured-product-icon" src="<?php echo plugin_dir_url( __FILE__ ); ?>imgs/cesta.png" alt="Icono de listado">
                        </div>
                        <div class="rec-featured-product-wrapper">
                          <?php
                          if( has_post_thumbnail( $product->ID ) ) {
                            echo "<img src='" . get_the_post_thumbnail_url( $product->ID ) . "'>";
                          }
                          ?>
                          <div class="rec-featured-product-wrapper-text">
                            <h4><?php echo ( get_sub_field('rec_pd_prod') ) ? get_sub_field('rec_pd_prod') : $product->post_title ; ?></h4>
                            <p>
                            <?php
                            $productRepo = new \WCAldi\Repositories\ProductRepo();
                            $price = $productRepo->getProductPriceByStore( $product->ID, $_COOKIE['current_store']['id'] )['unit_price'];
                            $measure_unit = $productRepo->getAttribute( $product->ID, 'Unidad de medida' );
                            $unit_content = $productRepo->getAttribute( $product->ID, 'Contenido unidad' );
                            echo "<strong>" . $unit_content . "</strong>";
                            if( $price != '' && $price != null ) {
                              echo " ( " . $price . "€/" . $measure_unit . " )";
                            }
                            ?></p>
                            <a href="<?php echo $product->guid; ?>" target="_blank"><?php _e('Ver producto','ideas'); ?></a>
                          </div>
                        </div>

                      </div>
                    <?php
                    }
                  endif;
                  ?>

                </div>
                <div class="col-xs-12 <?php echo ( $hasVideo && $verticalVideo ) ? 'col-md-7' : 'col-md-8' ; ?> ">
                  <?php if( $hasVideo && $verticalVideo  ) { ?>
                    <!-- Ingredientes -->
                    <div class="rec-ingredientes">
                      <div class="rec-ingredientes-header">
                        <h3><?php echo get_sub_field('rec_tit_ing'); ?></h3>
                        <img class="rec-ingredientes-icono" src="<?php echo plugin_dir_url( __FILE__ ); ?>imgs/lista-icono.png" alt="Icono de listado">
                      </div>
                      <div class="rec-ingredientes-wrapper">
                        <?php echo get_sub_field('rec_ing'); ?>
                      </div>
                    </div>
                  <?php } ?>

                  <div class="rec-contenido">
					<?php if (!$hasVideo): ?>
						<?php foreach(get_sub_field('rec_img') as $img) : ?>
							<img
								src="<?php echo $img['url']; ?>"
								alt="<?php echo $img['alt']; ?>"
								class="featured-receta hidden-xs hidden-sm"
								itemprop="image"
							>
						<?php endforeach; ?>
					<?php elseif (!$verticalVideo): ?>
						<?php $videoUrl =
							'//www.youtube.com/embed/' .
							convertYoutube(get_sub_field('rec_youtube')) .
							'?rel=0&amp;controls=0&amp;showinfo=0';
						?>

						<div class="rec-video-horizontal hidden-xs hidden-sm">
							<iframe
								src="<?= $videoUrl ?>"
								width="100%"
								height="100%"
								frameborder="0"
								allowfullscreen="allowfullscreen"
								gesture="media"
								allow="encrypted-media"
							></iframe>
						</div>
					<?php endif; ?>

                    <h3><?php echo get_sub_field('rec_tit_txt'); ?></h3>
                    <div itemprop="recipeInstructions"><?php echo get_sub_field('rec_txt'); ?></div>
                  </div>
                </div>
              <?php else: ?>
                <div class="col-xs-12">
                  <div class="rec-contenido">
                    <h3><?php echo get_sub_field('rec_tit_txt'); ?></h3>
                    <div itemprop="recipeInstructions"><?php echo get_sub_field('rec_txt'); ?></div>
                  </div>
                </div>
              <?php endif; ?>
            </div>

          </div>
        <?php } ?>
      <?php } ?>



      <!-- Productos relacionados -->
      <?php if(get_field('prr_act')) { ?>

      <?php
      echo "<div class='related-products'>";
      echo "<h3 class='related-products-h3'>".get_field('prr_txt')."</h3>";

      $btntxt = get_field('prr_btn');

      if(have_rows('prr_rep')) :

        $trows=0;
        while(have_rows('prr_rep')) { the_row();
          $trows++;
        }

        $wpr = 100/$trows;

        while(have_rows('prr_rep')) : the_row();


          echo "<div class='item' style='width:".$wpr."%'>";
          echo "<div class='item-wrapper'>";
          echo "<img src='".get_sub_field('prr_img')['url']."' alt='".get_sub_field('prr_img')['alt']."'>";
          echo "<div class='item-subitems'>";
          echo "<h4>".get_sub_field('prr_tit')."</h4>";
          echo "<div>".get_sub_field('prr_desc')."</div>";
          if(get_sub_field('prr_link')) {
            echo "<a href='".get_sub_field('prr_link')."' target='_blank'>".$btntxt."</a>";
          }
          if(get_sub_field('prr_precio')) {
            echo "<div class='precio'>".get_sub_field('prr_precio')."€</div>";
          }
          echo "</div>";
          echo "</div>";
          echo "</div>";

        endwhile;

      endif;

      ?>

      <?php
      echo "</div>";
      ?>
      <?php } ?>

  <?php endwhile; // end of the loop. ?>
  </div>

  <!-- RECIPE TAGS -->
  <?php include( plugin_dir_path( __FILE__ ).'template-tags.php' ); ?>

  <!-- ARROWS -->
  <?php echo do_shortcode('[prev-next-arrows]'); ?>

  <?php
  // Getting current URL to share it
  global $wp;
  $current_url = add_query_arg( $wp->query_string, '', home_url( $wp->request ) );
  ?>
  <div class="share-portfolio">
    <span class="share-portfolio-text"><?php _e('Compartir en'); ?></span>
    <a href="https://www.facebook.com/sharer/sharer.php?u=<?php echo $current_url; ?>" onclick="window.open(this.href, 'mywin','left=20,top=20,width=500,height=500,toolbar=1,resizable=0'); return false;"><i class="fa fa-facebook"></i></a>
    <a href="https://twitter.com/intent/tweet?text=<?php echo $current_url; ?>" onclick="window.open(this.href, 'mywin','left=20,top=20,width=500,height=500,toolbar=1,resizable=0'); return false;"><i class="fa fa-twitter"></i></a>
    <a href="mailto:?subject=[ALDI] <?php echo get_the_title(); ?>&body=<?php echo $current_url; ?>"><i class="fa fa-envelope"></i></a>
  </div>

  <!-- NEWSLETTER SUBSCRIPTION -->
  <?php echo do_shortcode('[suscribir-newsletter-posts]'); ?>

</article><!-- #main -->

<!-- RELATED POSTS -->
<?php echo do_shortcode('[related-portfolios]'); ?>

<?php get_footer(); ?>
